'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 5 June 2003 at 12:43:57 pm'!
"Change Set:		GeneralEnh-ajh
Date:			05 June 2003
Author:			Anthony Hannan

This adds some helpful methods to collections, streams, and other basic objects.  It also adds a nice CompiledMethod inspector.

This must be filed-in before PreContextEnh-ajh."!

Inspector subclass: #BasicInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Inspector'!
Inspector subclass: #CompiledMethodInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-Inspector'!

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive: arg1
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive: arg1 with: arg2
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive: arg1 with: arg2 with: arg3
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:20'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryNamedPrimitive: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7 with: arg8
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."
	<primitive:'' module:''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: 'ajh 1/31/2003 22:21'!
tryPrimitive: primIndex withArgs: argumentArray
	"This method is a template that the Smalltalk simulator uses to 
	execute primitives. See Object documentation whatIsAPrimitive."

	<primitive: 118>
	^ ContextPart primitiveFailToken! !


!Object methodsFor: 'accessing' stamp: 'ajh 1/21/2003 12:59'!
in: aBlock
	"Evaluate the given block with the receiver as its argument."

	^ aBlock value: self
! !

!Object methodsFor: 'comparing' stamp: 'ajh 2/2/2002 15:02'!
literalEqual: other

	^ self class == other class and: [self = other]! !

!Object methodsFor: 'converting' stamp: 'ajh 3/11/2003 10:27'!
asStringOrText
	"Answer a string that represents the receiver."

	^ self printString ! !

!Object methodsFor: 'copying' stamp: 'ajh 5/23/2002 00:38'!
copySameFrom: otherObject
	"Copy to myself all instance variables named the same in otherObject.
	This ignores otherObject's control over its own inst vars."

	| myInstVars otherInstVars match |
	myInstVars _ self class allInstVarNames.
	otherInstVars _ otherObject class allInstVarNames.
	myInstVars doWithIndex: [:each :index |
		(match _ otherInstVars indexOf: each) > 0 ifTrue:
			[self instVarAt: index put: (otherObject instVarAt: match)]].
	1 to: (self basicSize min: otherObject basicSize) do: [:i |
		self basicAt: i put: (otherObject basicAt: i)].
! !

!Object methodsFor: 'copying' stamp: 'ajh 1/27/2003 18:45'!
postCopy
	"self is a shallow copy, subclasses should copy fields as necessary to complete the full copy"

	^ self! !

!Object methodsFor: 'printing' stamp: 'ajh 9/20/2002 11:03'!
printOn: stream limit: size

	stream nextPutAll: (self printStringLimitedTo: size)! !

!Object methodsFor: 'inspecting' stamp: 'ajh 1/31/2003 15:49'!
basicInspect
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."

	BasicInspector openOn: self withEvalPane: false! !

!Object methodsFor: 'inspecting' stamp: 'ajh 2/3/2003 19:19'!
inspect
	"Create and schedule an Inspector in which the user can examine the receiver's variables."

	self inspectorClass openOn: self withEvalPane: true! !

!Object methodsFor: 'inspecting' stamp: 'ajh 2/3/2003 19:18'!
inspectorClass

	^ Inspector! !


!Boolean methodsFor: 'printing' stamp: 'ajh 5/23/2001 19:48'!
asBit
	"Return 1 for true, 0 for false"

	^ self subclassResponsibility! !


!Class methodsFor: 'private' stamp: 'ajh 10/9/2001 11:24'!
becomeClass: otherClass
	"Become the otherClass but it gets my name"

	| metaclass nm otherNm |
	otherClass format = self format ifFalse: [self error: 'class format needs to be the same or instances will be interpreted wrong'].

	metaclass _ self class.
	nm _ self name.
	otherNm _ otherClass name.
	self becomeForward: otherClass.
	metaclass becomeForward: otherClass class.
	self setName: nm.
	Smalltalk removeKey: otherNm.
	SystemOrganization removeElement: otherNm.
	Smalltalk garbageCollect.
	self superclass rebuildSubclasses.
	self rebuildSubclasses.
! !

!Class methodsFor: 'private' stamp: 'ajh 10/9/2001 11:33'!
rebuildSubclasses
	"You should probably garbageCollect before calling this"

	| classes |
	classes _ {} writeStream.
	Smalltalk allObjectsDo: [:x |
		(x isBehavior and: [x superclass == self]) ifTrue: [
			classes nextPut: x]].
	subclasses _ classes contents.
! !


!Collection methodsFor: 'enumerating' stamp: 'ajh 6/5/2003 11:59'!
collectArray: aBlock 
	"Same as collect: except always return an array"

	| array i |
	array _ Array new: self size.
	i _ 0.
	self do: [:elem |
		array at: (i _ i + 1) put: (aBlock value: elem)].
	^ array! !


!False methodsFor: 'printing' stamp: 'ajh 5/23/2001 19:49'!
asBit
	"Return 1 for true, 0 for false"

	^ 0! !


!Inspector methodsFor: 'accessing' stamp: 'ajh 2/3/2003 19:19'!
inspect: anObject 
	"Initialize the receiver so that it is inspecting anObject. There is no 
	current selection."

	| c |
	c _ anObject inspectorClass.
	(self class ~= c and: [self class format = c format]) ifTrue: [
		self primitiveChangeClassTo: c basicNew].
	self initialize.
	object _ anObject.
	selectionIndex _ 0.
	contents _ ''! !


!BasicInspector methodsFor: 'as yet unclassified' stamp: 'ajh 1/31/2003 15:49'!
inspect: anObject 
	"Initialize the receiver so that it is inspecting anObject. There is no 
	current selection."

	self initialize.
	object _ anObject.
	selectionIndex _ 0.
	contents _ ''! !


!CompiledMethodInspector methodsFor: 'accessing' stamp: 'ajh 1/18/2003 13:47'!
fieldList

	| keys |
	keys _ OrderedCollection new.
	keys add: 'self'.
	keys add: 'all bytecodes'.
	keys add: 'header'.
	1 to: object numLiterals do: [ :i |
		keys add: 'literal', i printString ].
	object initialPC to: object size do: [ :i |
		keys add: i printString ].
	^ keys asArray
	! !

!CompiledMethodInspector methodsFor: 'selecting' stamp: 'ajh 3/20/2003 00:17'!
contentsIsString
	"Hacked so contents empty when deselected"

	^ #(0 2 3) includes: selectionIndex! !

!CompiledMethodInspector methodsFor: 'selecting' stamp: 'ajh 1/18/2003 13:56'!
selection

	| bytecodeIndex |
	selectionIndex = 0 ifTrue: [^ ''].
	selectionIndex = 1 ifTrue: [^ object ].
	selectionIndex = 2 ifTrue: [^ object symbolic].
	selectionIndex = 3 ifTrue: [^ object headerDescription].
	selectionIndex <= (object numLiterals + 3) 
		ifTrue: [ ^ object objectAt: selectionIndex - 2 ].
	bytecodeIndex _ selectionIndex - object numLiterals - 3.
	^ object at: object initialPC + bytecodeIndex - 1! !

!CompiledMethodInspector methodsFor: 'selecting' stamp: 'ajh 3/20/2001 11:56'!
selectionUnmodifiable
	"Answer if the current selected variable is unmodifiable via acceptance in the code pane.  For most inspectors, no selection and a selection of self (selectionIndex = 1) are unmodifiable"

	^ true! !


!ContextVariablesInspector methodsFor: 'accessing' stamp: 'ajh 1/31/2003 15:45'!
inspect: anObject 
	"Initialize the receiver so that it is inspecting anObject. There is no 
	current selection."

	self initialize.
	object _ anObject.
	selectionIndex _ 0.
	contents _ ''! !


!InstructionPrinter methodsFor: 'initialize-release' stamp: 'ajh 3/20/2001 11:30'!
printInstruction: aPc on: aStream 
	"Append to the stream, aStream, a description of the bytecode at aPic in the 
	instruction stream."
	
	stream _ aStream.
	oldPC _ pc _ aPc.
	super interpretNextInstructionFor: self! !


!LookupKey methodsFor: 'accessing' stamp: 'ajh 3/24/2003 21:14'!
name

	^ self key isString
		ifTrue: [self key]
		ifFalse: [self key printString]! !


!Message methodsFor: 'accessing' stamp: 'ajh 10/9/2001 16:32'!
lookupClass

	^ lookupClass! !

!Message methodsFor: 'printing' stamp: 'ajh 10/9/2001 15:31'!
printOn: stream

	args isEmpty ifTrue: [^ stream nextPutAll: selector].
	args with: selector keywords do: [:arg :word |
		stream nextPutAll: word.
		stream space.
		arg printOn: stream.
		stream space.
	].
	stream skip: -1.
! !

!Message methodsFor: 'private' stamp: 'ajh 9/23/2001 04:59'!
lookupClass: aClass

	lookupClass _ aClass! !

!Message methodsFor: 'private' stamp: 'ajh 3/9/2003 19:25'!
setSelector: aSymbol

	selector _ aSymbol.
! !

!Message methodsFor: 'sending' stamp: 'ajh 1/22/2003 11:51'!
sendTo: receiver
	"answer the result of sending this message to receiver"

	^ receiver perform: selector withArguments: args! !


!Number methodsFor: 'intervals' stamp: 'ajh 9/27/2002 21:20'!
extend: size

	^ self to: self + size - 1! !


!LargePositiveInteger methodsFor: 'converting' stamp: 'ajh 7/25/2001 22:28'!
as31BitSmallInt
	"This is only for 31 bit numbers.  Keep my 31 bits the same, but put them in a small int.  The small int will be negative since my 31st bit is 1.  We know my 31st bit is 1 because otherwise I would already be a positive small int."

	self highBit = 31 ifFalse: [self error: 'more than 31 bits can not fit in a SmallInteger'].

	^ self - 16r80000000! !


!Object class methodsFor: 'instance creation' stamp: 'ajh 5/23/2002 00:35'!
newFrom: aSimilarObject
	"Create an object that has similar contents to aSimilarObject.
	If the classes have any instance varaibles with the same names, copy them across.
	If this is bad for a class, override this method."

	^ (self isVariable
		ifTrue: [self basicNew: aSimilarObject basicSize]
		ifFalse: [self basicNew]
	  ) copySameFrom: aSimilarObject! !


!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 17:53'!
atLast: indexFromEnd
	"Return element at indexFromEnd from the last position.
	 atLast: 1, returns the last element"

	^ self atLast: indexFromEnd ifAbsent: [self errorIndexOutOfRange]! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 17:52'!
atLast: indexFromEnd ifAbsent: block
	"Return element at indexFromEnd from the last position.
	 atLast: 1 ifAbsent: [] returns the last element"

	^ self at: self size + 1 - indexFromEnd ifAbsent: block! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 6/27/2002 18:10'!
atLast: indexFromEnd put: obj
	"Set the element at indexFromEnd from the last position.
	 atLast: 1 put: obj, sets the last element"

	^ self at: self size + 1 - indexFromEnd put: obj! !

!SequenceableCollection methodsFor: 'accessing' stamp: 'ajh 8/18/2001 19:04'!
indicesOf: subSet

	^ subSet collect: [:x | self indexOf: x ifAbsent: [self errorNotFound: x]]! !

!SequenceableCollection methodsFor: 'copying' stamp: 'ajh 9/13/2002 21:47'!
copyGrowBy: delta
	"Return a copy of self whose size is larger by delta.  The new elements will be filled in with nil or zero depending on the type of class (holds pointers or bytes/words)"

	| copy |
	copy _ self species ofSize: self size + delta.
	copy replaceFrom: 1 to: self size with: self startingAt: 1.
	^ copy! !

!SequenceableCollection methodsFor: 'copying' stamp: 'ajh 9/13/2002 21:49'!
copyGrowTo: newSize
	"Return a copy of self whose size is newSize (assumed larger or equal to self size).  The new elements will be filled in with nil or zero depending on the type of class (holds pointers or bytes/words)"

	^ self copyGrowBy: newSize - self size! !

!SequenceableCollection methodsFor: 'copying' stamp: 'ajh 9/27/2002 12:09'!
copyWithFirst: newElement 
	"Answer a copy of the receiver that is 1 bigger than the receiver with newElement as the first element."

	| newIC |
	newIC _ self species ofSize: self size + 1.
	newIC 
		replaceFrom: 2
		to: self size + 1
		with: self
		startingAt: 1.
	newIC at: 1 put: newElement.
	^ newIC! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 15:03'!
allButFirstDo: block

	2 to: self size do:
		[:index | block value: (self at: index)]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 15:01'!
allButLastDo: block

	1 to: self size - 1 do:
		[:index | block value: (self at: index)]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/3/2001 20:58'!
detectIndex: block

	^ self detectIndex: block ifNone: [self errorNotFound: block]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/3/2001 20:58'!
detectIndex: block ifNone: absentBlock

	1 to: self size do: [:i |
		(block value: (self at: i)) ifTrue: [^ i]].
	^ absentBlock value! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 3/13/2003 13:10'!
reverseDetect: block

	^ self reverseDetect: block ifNone: [self errorNotFound]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 10:58'!
reverseDetect: block ifNone: absentBlock

	self size to: 1 by: -1 do: [:i |
		(block value: (self at: i)) ifTrue: [^ self at: i]].
	^ absentBlock value! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/11/2001 12:26'!
reverseDetectIndex: block ifNone: absentBlock

	self size to: 1 by: -1 do: [:i |
		(block value: (self at: i)) ifTrue: [^ i]].
	^ absentBlock value! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 1/5/2002 01:33'!
with: otherCollection padding: fillObj collect: twoArgBlock 
	"Collect and return the result of evaluating twoArgBlock with corresponding elements from this collection and otherCollection.  If one collection is short substitute fillObj as necessary to finish the other collection"

	| firstSize secondSize result |
	firstSize _ self size.
	secondSize _ otherCollection size.
	result _ Array new: (firstSize max: secondSize).
	1 to: result size do: [:i |
	   result at: i put: (twoArgBlock
		value: (i > firstSize ifTrue: [fillObj] ifFalse: [self at: i])
		value: (i > secondSize ifTrue: [fillObj] ifFalse: [otherCollection at: i])
	   )
	].
	^ result! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 1/5/2002 01:05'!
with: otherCollection padding: fillObj do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection.  If one collection is short substitute fillObj as necessary to finish the other collection"

	| firstSize secondSize |
	firstSize _ self size.
	secondSize _ otherCollection size.
	1 to: (firstSize max: secondSize) do: [:i |
	   twoArgBlock
		value: (i > firstSize ifTrue: [fillObj] ifFalse: [self at: i])
		value: (i > secondSize ifTrue: [fillObj] ifFalse: [otherCollection at: i])
	].
! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ajh 8/17/2001 21:02'!
with: otherCollection withIndexDo: threeArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection."

	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	1 to: self size do: [:index |
		threeArgBlock 
			value: (self at: index)
			value: (otherCollection at: index)
			value: index]! !

!SequenceableCollection methodsFor: 'moving' stamp: 'ajh 2/2/2002 15:37'!
slide: interval by: distance
	"Move the elements in inteval down(neg)/up(pos) by distance while sliding elements it displaces the other way"

	^ distance > 0
		ifTrue: [self slide: interval up: distance]
		ifFalse: [self slide: interval down: distance]! !

!SequenceableCollection methodsFor: 'moving' stamp: 'ajh 2/2/2002 16:27'!
slide: interval down: distance
	"Destructively move the elements in inteval down by distance while sliding elements it displaces up by interval size"

	| displacedInterval displaced |
	displacedInterval _ interval first - distance to: interval first - 1.
	displaced _ self atAll: displacedInterval.
	self replaceFrom: displacedInterval first to: displacedInterval first + interval size - 1 with: self startingAt: interval first.
	self replaceFrom: displacedInterval first + interval size to: interval last with: displaced.

"{$a. $b. $c. $d. $e} slide: (3 to: 5) down: 2"! !

!SequenceableCollection methodsFor: 'moving' stamp: 'ajh 2/2/2002 17:35'!
slide: interval up: distance
	"Destructively move the elements in inteval up by distance while sliding elements it displaces down by interval size"

	| displacedInterval elements |
	displacedInterval _ interval last + 1 to: interval last + distance.
	elements _ self atAll: interval.
	self replaceFrom: interval first to: interval first + displacedInterval size - 1 with: self startingAt: displacedInterval first.
	self replaceFrom: interval first + displacedInterval size to: displacedInterval last with: elements.

"{$a. $b. $c. $d. $e} slide: (1 to: 2) up: 2"! !


!Array methodsFor: 'comparing' stamp: 'ajh 2/2/2002 15:03'!
literalEqual: other

	self class == other class ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	self with: other do: [:e1 :e2 |
		(e1 literalEqual: e2) ifFalse: [^ false]].
	^ true! !

!Array methodsFor: 'converting' stamp: 'ajh 9/8/2002 17:45'!
elementsExchangeIdentityWith: otherArray
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  At the same time, all pointers to the elements of otherArray are replaced by pointers to the corresponding elements of this array.  The identityHashes remain with the pointers rather than with the objects so that objects in hashed structures should still be properly indexed after the mutation."

	<primitive: 128>
	otherArray class == Array ifFalse: [^ self error: 'arg must be array'].
	self size = otherArray size ifFalse: [^ self error: 'arrays must be same size'].
	(self anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].
	(otherArray anySatisfy: [:obj | obj class == SmallInteger]) ifTrue: [^ self error: 'can''t become SmallIntegers'].

	"Must have failed because not enough space in forwarding table (see ObjectMemory-prepareForwardingTableForBecoming:with:twoWay:).  Do GC and try again only once"
	(Smalltalk bytesLeft: true) = Smalltalk primitiveGarbageCollect
		ifTrue: [^ self primitiveFailed].
	^ self elementsExchangeIdentityWith: otherArray! !


!CompiledMethod methodsFor: 'comparing' stamp: 'ajh 1/31/2003 17:13'!
= method
	"Answer whether the receiver implements the same code as the 
	argument, method."

	(method isKindOf: CompiledMethod) ifFalse: [^false].
	self endPC = method endPC ifFalse: [^false].
	self header = method header ifFalse: [^false].
	self initialPC to: self endPC do:
		[:i | (self at: i) = (method at: i) ifFalse: [^false]].
	^ self literals literalEqual: method literals! !

!CompiledMethod methodsFor: 'printing' stamp: 'ajh 2/9/2003 14:17'!
longPrintOn: aStream
	"List of all the byte codes in a method with a short description of each" 

	self longPrintOn: aStream indent: 0! !

!CompiledMethod methodsFor: 'printing' stamp: 'ajh 3/20/2001 11:41'!
symbolic
	"Answer a String that contains a list of all the byte codes in a method 
	with a short description of each."

	| aStream |
	aStream _ WriteStream on: (String new: 1000).
	self longPrintOn: aStream.
	^aStream contents! !

!CompiledMethod methodsFor: 'literals' stamp: 'ajh 2/9/2003 13:15'!
headerDescription
	"Answer a description containing the information about the form of the 
	receiver and the form of the context needed to run the receiver."

	| s |
	s _ '' writeStream.
	self header printOn: s.
	s cr; nextPutAll: '"primitive: '.
	self primitive printOn: s.
	s cr; nextPutAll: ' numArgs: '.
	self numArgs printOn: s.
	s cr; nextPutAll: ' numTemps: '.
	self numTemps printOn: s.
	s cr; nextPutAll: ' numLiterals: '.
	self numLiterals printOn: s.
	s cr; nextPutAll: ' frameSize: '.
	self frameSize printOn: s.
	s cr; nextPutAll: ' isClosureCompiled: '.
	self isClosureCompiled printOn: s.
	s nextPut: $"; cr.
	^ s contents! !

!CompiledMethod methodsFor: 'user interface' stamp: 'ajh 2/3/2003 19:18'!
inspectorClass

	^ CompiledMethodInspector! !


!Interval methodsFor: 'arithmetic' stamp: 'ajh 3/13/2003 15:45'!
+ number

	^ start + number to: stop + number by: step! !

!Interval methodsFor: 'arithmetic' stamp: 'ajh 3/13/2003 15:46'!
- number

	^ start - number to: stop - number by: step! !


!LinkedList methodsFor: 'accessing' stamp: 'ajh 8/6/2002 15:46'!
at: index

	| i |
	i _ 0.
	self do: [:link |
		(i _ i + 1) = index ifTrue: [^ link]].
	^ self errorSubscriptBounds: index! !

!LinkedList methodsFor: 'adding' stamp: 'ajh 8/22/2002 14:17'!
add: link before: otherLink

	| aLink |
	firstLink == otherLink ifTrue: [^ self addFirst: link].
	aLink _ firstLink.
	[aLink == nil] whileFalse: [
		aLink nextLink == otherLink ifTrue: [
			link nextLink: aLink nextLink.
			aLink nextLink: link.
			^ link
		].
		 aLink _ aLink nextLink.
	].
	^ self errorNotFound: otherLink! !

!LinkedList methodsFor: 'enumerating' stamp: 'ajh 8/6/2002 16:39'!
species

	^ Array! !


!OrderedCollection methodsFor: 'removing' stamp: 'ajh 8/13/2002 17:07'!
removeAll

	firstIndex to: lastIndex do: [:i | array at: i put: nil].
	self reset! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 10/3/2002 17:29'!
bottom

	^ self first! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/5/2003 12:37'!
bottomToTopDo: block

	self do: block! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/20/2001 13:04'!
pop

	^ self removeLast! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/27/2002 17:20'!
pop: n
	"Pop top n object into an array with top in last position"

	| list |
	list _ Array new: n.
	n to: 1 by: -1 do: [:i |
		list at: i put: self pop].
	^ list! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/30/2002 17:13'!
popTo: index
	"Pop objects into an array until topIndex is at index"

	^ self pop: (self size - index)! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/20/2001 13:04'!
push: obj

	^ self addLast: obj! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 10/1/2002 12:59'!
pushAll: obj

	^ self addAll: obj! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 6/20/2001 13:04'!
top

	^ self last! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 3/1/2003 17:04'!
top: index

	^ self atLast: index! !

!OrderedCollection methodsFor: 'stack' stamp: 'ajh 10/3/2002 17:35'!
topToBottomDo: block

	self reverseDo: block! !


!SmallInteger methodsFor: 'converting' stamp: 'ajh 7/25/2001 22:34'!
as31BitSmallInt
	"Polymorphic with LargePositiveInteger (see comment there).
	 Return self since all SmallIntegers are 31 bits"

	^ self! !


!Stream methodsFor: 'accessing' stamp: 'ajh 7/31/2001 20:34'!
printOn: stream

	super printOn: stream.
	stream space.
	self contents printOn: stream.
! !

!Stream methodsFor: 'enumerating' stamp: 'ajh 12/29/2001 18:04'!
includes: obj

	| pos result |
	pos _ self position.
	self setToEnd.
	result _ self contents includes: obj.
	self position: pos.
	^ result! !


!PositionableStream methodsFor: 'accessing' stamp: 'ajh 9/22/2001 01:16'!
at: pos
	"Return the element at pos"

	pos > readLimit ifTrue: [self errorOutOfBounds].
	^ collection at: pos! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 1/18/2002 01:03'!
back
	"Go back one element and return it.  Use indirect messages in case I am a StandardFileStream"

	self position = 0 ifTrue: [self errorCantGoBack].
	self position = 1 ifTrue: [self position: 0.  ^ nil].
	self skip: -2.
	^ self next
! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 7/17/2001 21:49'!
copyIntoStream: aWriteStream

	1 to: position do: [:i |
		aWriteStream nextPut: (collection at: i)]! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 5/18/2001 21:42'!
current
	"Return the element at the current position"

	^ collection at: position! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 7/18/2001 00:22'!
do: block

	1 to: readLimit do: [:i |
		block value: (collection at: i)]! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 1/18/2002 01:02'!
peekBack
	"Return the element at the previous position, without changing position.  Use indirect messages in case self is a StandardFileStream."

	| element |
	element _ self back.
	self skip: 1.
	^ element! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 7/30/2001 02:24'!
previous
	"Return the element at the previous position"

	^ collection at: position - 1! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 1/22/2003 17:56'!
rest

	| p rest |
	p _ self position.
	rest _ self upToEnd.
	self position: p.
	^ rest! !

!PositionableStream methodsFor: 'accessing' stamp: 'ajh 7/17/2001 21:49'!
reverseCopyIntoStream: aWriteStream

	position to: 1 by: -1 do: [:i |
		aWriteStream nextPut: (collection at: i)]! !

!PositionableStream methodsFor: 'testing' stamp: 'ajh 6/18/2002 12:55'!
identityIncludes: obj

	| pos |
	pos _ self position.
	self setToEnd.
	1 to: self position do: [:i |
		(collection at: i) == obj ifTrue: [
			self position: pos.
			^ true]
	].
	self position: pos.
	^ false! !

!PositionableStream methodsFor: 'testing' stamp: 'ajh 12/29/2001 21:51'!
includes: obj

	| pos |
	pos _ self position.
	self setToEnd.
	1 to: self position do: [:i |
		(collection at: i) = obj ifTrue: [
			self position: pos.
			^ true]
	].
	self position: pos.
	^ false! !

!PositionableStream methodsFor: 'testing' stamp: 'ajh 7/21/2001 12:57'!
notEmpty

	^ self isEmpty not! !

!PositionableStream methodsFor: 'fileIn/Out' stamp: 'ajh 1/18/2002 01:02'!
backChunk
	"Answer the contents of the receiver back to the previous terminator character.  Doubled terminators indicate an embedded terminator character."
	| terminator out ch |
	terminator _ $!!.
	out _ WriteStream on: (String new: 1000).
	[(ch _ self back) == nil] whileFalse: [
		(ch == terminator) ifTrue: [
			self peekBack == terminator ifTrue: [
				self back.  "skip doubled terminator"
			] ifFalse: [
				^ out contents reversed  "we're done!!"
			].
		].
		out nextPut: ch.
	].
	^ out contents reversed! !


!ReadStream methodsFor: 'accessing' stamp: 'ajh 9/5/2002 22:11'!
readStream
	"polymorphic with SequenceableCollection.  Return self"

	^ self! !


!String methodsFor: 'converting' stamp: 'ajh 5/18/2001 11:56'!
uniqueAmong: wordList
	"Return a string like self that is unique among wordList"

	| candidate n |
	n _ 0.
	candidate _ self.
	[wordList includes: candidate] whileTrue: [
		candidate _ self, (n _ n + 1) printString].
	^ candidate! !

!String methodsFor: 'user interface' stamp: 'ajh 9/25/2002 13:10'!
asExplorerString
	^ self printString! !


!TextColor class methodsFor: 'constants' stamp: 'ajh 9/10/2002 02:26'!
gray
	^ self new color: Color gray! !


!True methodsFor: 'printing' stamp: 'ajh 5/23/2001 19:49'!
asBit
	"Return 1 for true, 0 for false"

	^ 1! !


!WriteStream methodsFor: 'accessing' stamp: 'ajh 9/22/2001 01:19'!
at: pos
	"Return the element at pos"

	readLimit _ readLimit max: position.
	^ super at: pos! !

!WriteStream methodsFor: 'accessing' stamp: 'ajh 9/22/2001 01:19'!
at: pos put: value
	"Set the element at pos"

	pos > (readLimit _ readLimit max: position) ifTrue: [self errorOutOfBounds].
	^ collection at: pos put: value! !

!WriteStream methodsFor: 'accessing' stamp: 'ajh 7/18/2001 00:25'!
do: block

	readLimit _ readLimit max: position.
	1 to: position do: [:i |
		block value: (collection at: i)]! !

!WriteStream methodsFor: 'positioning' stamp: 'ajh 7/27/2001 23:07'!
resetTo: pos
	readLimit _ position _ pos.! !

!WriteStream methodsFor: 'positioning' stamp: 'ajh 5/25/2001 20:19'!
setToEnd 
	"Refer to the comment in PositionableStream|setToEnd."

	readLimit _ readLimit max: position.
	super setToEnd.! !

!WriteStream methodsFor: 'character writing' stamp: 'ajh 2/9/2003 14:15'!
tabs: numTabs
	"Append numTabs tab characters to the receiver."

	numTabs timesRepeat: [self tab]! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 8/25/2001 10:45'!
current: obj
	"Set the element at the current position"

	^ collection at: position put: obj! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 7/18/2001 00:19'!
insert: obj

	^ self insertAll: {obj}! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 8/1/2001 19:35'!
insertAll: coll
	"slide all elements after current position forward by coll size, then insert coll elements in the new positions.  My position will point to the last inserted element"

	| n |
	n _ coll size.
	readLimit + n > writeLimit ifTrue: [
		collection _ collection, (collection class new: n).
		writeLimit _ collection size].
	readLimit to: position + 1 by: -1 do: [:i |
		collection at: i + n put: (collection at: i)].
	1 to: n do: [:i |
		collection at: position + i put: (coll at: i)].
	readLimit _ readLimit + n.
	position _ position + n.


" #() writeStream 
	nextPut: $a;
	nextPut: $b;
	nextPut: $c;
	position: 1;
	insertAll: #($x $y);
	setToEnd;
	contents "! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 7/20/2001 19:43'!
insertNext: n
	"slide all elements after current position forward by n, while inserting zeros in next n elements (zeros are used in case collection is a ByteArray).  Keep position the same"

	readLimit + n > writeLimit ifTrue: [
		collection _ collection, (collection class new: n).
		writeLimit _ collection size].
	readLimit to: position + 1 by: -1 do: [:i |
		collection at: i + n put: (collection at: i)].
	position + 1 to: position + n do: [:i |
		collection at: i put: 0].
	readLimit _ readLimit + n.

"
 #() writeStream 
	nextPut: $a;
	nextPut: $b;
	nextPut: $c;
	position: 1;
	insertNext: 2;
	setToEnd;
	contents
"! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 8/20/2001 23:45'!
removeCurrent
	"Remove element under current position (sliding those after it down by one).  Move position back by one (point to the previous element)"

	self skip: -1.
	self removeNext: 1.
! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 7/27/2001 21:54'!
removeFirst

	| pos |
	pos _ self position.
	self reset.
	self removeNext.
	self position: pos - 1.! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 5/25/2001 17:50'!
removeNext
	"slide all elements after current position down by one, removing the next element.  Keep position the same"

	self atEnd ifTrue: [^ nil].
	self removeNext: 1! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 5/21/2001 19:17'!
removeNext: n
	"slide all elements after current position down by n, removing the next n element.  Keep position the same"

	collection 
		replaceFrom: position + 1 
		to: readLimit - n 
		with: collection 
		startingAt: position + 1 + n.
	readLimit _ readLimit - n.

"
 #() writeStream 
	nextPut: $a;
	nextPut: $b;
	nextPut: $c;
	nextPut: $d;
	position: 1;
	removeNext: 2;
	setToEnd;
	contents
"! !

!WriteStream methodsFor: 'inserting/shifting' stamp: 'ajh 7/20/2001 19:43'!
shiftNext: delta
	"Shift my elements from next to end by delta positions.  If negative, the next delta elements will be removed.  If positive, zeros will be inserted.  The position will remain the same"

	delta < 0
		ifTrue: [self removeNext: 0 - delta]
		ifFalse: [self insertNext: delta]! !


!ReadWriteStream methodsFor: 'accessing' stamp: 'ajh 7/18/2001 00:24'!
do: block

	readLimit _ readLimit max: position.
	1 to: readLimit do: [:i |
		block value: (collection at: i)]! !

!ReadWriteStream methodsFor: 'converting' stamp: 'ajh 9/14/2002 20:37'!
readStream
	"polymorphic with SequenceableCollection.  Return self"

	^ self! !

Object removeSelector: #tryNamedPrimitive!
Object removeSelector: #tryNamedPrimitive:!
Object removeSelector: #tryNamedPrimitive:with:!
Object removeSelector: #tryNamedPrimitive:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:with:with:with:!
Object removeSelector: #tryNamedPrimitive:with:with:with:with:with:with:with:!
Object removeSelector: #tryPrimitive:withArgs:!
